#include <Wire.h>                 // libreria necesaria para el módulo I2C
#include <LiquidCrystal_I2C.h>    // libreria necesaria para el display de la pantalla
 
LiquidCrystal_I2C lcd(0x27,16,2);  // configuramos la pantalla lcd
                     

// Pines LED
#define LEDVERDE 2
#define LEDAMARILLO 3
#define LEDROJO 4
#define PILA 0
 
// Variables
int analogValor = 0;
float voltaje = 0;
int ledDelay = 800;
 
// Umbrales
float maximo = 1.50;
float medio = 1.20;
float minimo = 0.30;
 
void setup() {
  
  lcd.init();                      
  lcd.backlight();                
  lcd.setCursor(0,0);             
 
  // Los pines de LED en modo salida
  pinMode(LEDVERDE, OUTPUT);
  pinMode(LEDAMARILLO, OUTPUT);
  pinMode(LEDROJO, OUTPUT);
 
}
 
void loop() {
  // Leemos valor de la entrada analógica
  analogValor = analogRead(PILA);
 
  // Obtenemos el voltaje
  voltaje = ((5.00 * analogValor)/1024);
  Serial.print("Voltaje: ");
  Serial.println(voltaje);
 
  // Dependiendo del voltaje mostramos un LED u otro
  if (voltaje >= maximo)
  {
    digitalWrite(LEDVERDE, HIGH);
    delay(ledDelay);
    digitalWrite(LEDVERDE, LOW);
  }
  else if (voltaje < maximo && voltaje > medio)
  {
    digitalWrite(LEDAMARILLO, HIGH);
    delay(ledDelay);
    digitalWrite(LEDAMARILLO, LOW);
  }
  else if (voltaje < medio && voltaje > minimo)
  {
    digitalWrite(LEDROJO, HIGH);
    delay(ledDelay);
    digitalWrite(LEDROJO, LOW);
  }
 
  // Apagamos todos los LEDs
  digitalWrite(LEDVERDE, LOW);
  digitalWrite(LEDAMARILLO, LOW);
  digitalWrite(LEDROJO, LOW);

  // Borramos toda la pantalla para actualizarla
  lcd.clear();
  // IMPRIMIR UN ENCABEZADO
  lcd.print("  VOLTIMETRO ");
 
 
  // Mostramos el valor del voltaje, después de la lectura del pin analógico
  lcd.setCursor(6, 1);
  lcd.print(voltaje, 1);
 
  // Esperamos un segundo antes de continuar
  delay (1000);
}
